<i18n>
{
  "fr": {
    "annual-distance": "Distance annuelle",
    "annual-emissions": "Emissions annuelles",
    "annual-emissions-carpooling": "Emissions annuelles (avec covoiturage)",
    "new-simulation": "Ajouter une simulation",
    "reset": "Réinitialiser"
  },
  "en": {
    "annual-distance": "Annual distance",
    "annual-emissions": "Annual emissions",
    "annual-emissions-carpooling": "Annual emissions (with carpooling)",
    "new-simulation": "Add a simulation",
    "reset": "Reset"
  }
}
</i18n>

<template>
  <section class="hero is-default is-bold">
    <div class="hero-body">
      <div class="container">
        <div class="columns">
          <div
            v-if="!submitted"
            class="column is-8 is-offset-2"
          >
            <commute-form
              :isSurvey="true"
              :year="year"
              :commute="commute"
              @submit="validate"
              position="engineer"
              v-bind:hasWorkingDay2Changed.sync="hasWorkingDay2Changed"
              :isSimulation="true"
            />
          </div>

          <div
            v-else
            class="column is-8 is-offset-2"
          >
            <survey-summary
              :commute="commute"
              :year="year"
              :submitted="submitted"
              :isSimulation="true"
            />
            <br />
            <div
              class="columns"
            >
              <div class="column">
                <b-notification :closable="false">
                  <div class="level-item has-text-centered">
                    <div>
                      <p class="heading has-text-distance">
                        {{ $t('annual-distance') }}
                      </p>
                      <div class="title is-size-2 has-text-distance">
                        <p>
                          {{ (Math.round(distance * 100) / 100) | splitNumber }}
                          <span class="is-size-4">km</span>
                        </p>
                      </div>
                    </div>
                  </div>
                </b-notification>
              </div>
              <div class="column">
                <b-notification :closable="false">
                  <div class="level-item has-text-centered">
                    <div>
                      <p
                        v-if="isCarpooling"
                        class="heading has-text-carbone"
                      >
                        {{ $t('annual-emissions-carpooling') }}
                      </p>
                      <p
                        v-else
                        class="heading has-text-carbone"
                      >
                        {{ $t('annual-emissions') }}
                      </p>
                      <div class="title is-size-2 has-text-carbone">
                        <p>
                          {{ (Math.round(intensity.intensity * 100) / 100) | splitNumber }} &plusmn; {{ (Math.round(intensity.uncertainty * 100) / 100) | splitNumber }}
                          <span class="is-size-4">{{ $t('kg.co2e') }}</span>
                        </p>
                      </div>
                    </div>
                  </div>
                </b-notification>
              </div>
            </div>
            <ghgi-information-fr
              v-if="submitted"
              :userDeplacements="allSimulations"
            />
            <br />
            <div class="columns">
              <div class="column">
                <button
                  class="button is-fullwidth"
                  @click="resetSimulations"
                >
                  <span class="icon is-small"
                    ><i class="sui sui-refresh"></i
                  ></span>
                  <span>{{ $t('reset') }}</span>
                </button>
              </div>
              <div class="column">
                <button
                  class="button is-fullwidth is-primary"
                  @click="newSimulation"
                >
                  <span class="icon is-small"
                    ><i class="sui sui-plus"></i
                  ></span>
                  <span>{{ $t('new-simulation') }}</span>
                </button>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import Commute from '@/models/carbon/Commute.js'

export default {
  name: 'CommutesSimulation',
  components: {
    'survey-summary': () => import('@/components/carbon/forms/SurveySummary.vue'),
    'commute-form': () => import('@/components/carbon/forms/CommuteForm.vue'),
    'ghgi-information-fr': () => import('@/components/carbon/graphics/GHGIInformationFR.vue')
  },
  data () {
    return {
      submitted: false,
      error: '',
      year: new Date().getFullYear(),
      surveyActive: false,
      hasWorkingDay2Changed: false,
      emptyCommute: {
        'seqID': null,
        'position': null,
        'nWorkingDay': null,
        'walking': 0,
        'bike': 0,
        'ebike': 0,
        'escooter': 0,
        'motorbike': 0,
        'car': 0,
        'bus': 0,
        'busintercity': 0,
        'tram': 0,
        'train': 0,
        'expressrailway': 0,
        'subway': 0,
        'motorbikepooling': 1,
        'carpooling': 1,
        'hasWorkingDay2': false,
        'nWorkingDay2': null,
        'engine': null,
        'walking2': 0,
        'bike2': 0,
        'ebike2': 0,
        'escooter2': 0,
        'motorbike2': 0,
        'car2': 0,
        'bus2': 0,
        'busintercity2': 0,
        'tram2': 0,
        'train2': 0,
        'expressrailway2': 0,
        'subway2': 0,
        'motorbikepooling2': 1,
        'carpooling2': 1,
        'engine2': null
      },
      commute: null
    }
  },
  computed: {
    allSimulations: function () {
      return this.$store.getters['simulations/commutes']
    },
    intensity: function () {
      let commute = Commute.createFromObj(this.commute)
      return commute.getTotalIntensity(this.year, 2)
    },
    distance: function () {
      let commute = Commute.createFromObj(this.commute)
      return commute.getDistanceTotale(this.year)
    },
    isCarpooling: function () {
      let commute = Commute.createFromObj(this.commute)
      return commute.isCarpooling()
    }
  },
  methods: {
    validate (commute) {
      this.commute = Commute.createFromObj(commute)
      this.$store.commit(
        'simulations/ADD_COMMUTE',
        {
          'commute': this.commute,
          'year': this.year
        }
      )
      this.submitted = true
      window.scrollTo(0, 0)
    },
    resetSimulations () {
      this.$store.commit('simulations/RESET_COMMUTES')
      this.commute = Object.assign({}, this.emptyCommute)
      this.submitted = false
    },
    newSimulation () {
      this.commute = Object.assign({}, this.emptyCommute)
      this.year = new Date().getFullYear()
      this.submitted = false
      this.hasWorkingDay2Changed = false
      window.scrollTo(0, 0)
    }
  },
  mounted () {
    if (this.allSimulations.length === 1) {
      this.commute = this.allSimulations[0].commute
      this.year = this.allSimulations[0].year
      this.submitted = true
      window.scrollTo(0, 0)
    } else {
      this.commute = Object.assign({}, this.emptyCommute)
      this.year = new Date().getFullYear()
      this.submitted = false
    }
  }
}
</script>

<style>
  .has-text-distance {
    color: #8e6a9e !important;
  }
  .has-text-carbone {
    color: #208dbc !important;
  }
</style>
